#include "ccp.pml"

/* Protocol Specific Part: shared by all role processes*/

/* Channels used to maintain the states of cmmitments */
chan to_buyer_cc = [CHANLEN] of {mtype, byte};
chan to_seller_cc = [CHANLEN] of {mtype, byte};

/* Global Commitment IDs for sharing among different role processes */

byte buyer_cid;
byte seller_cid;

mtype = { reqForQuote, rejectQuote, quote, acceptQuote,CC };

mtype = { paymentInfo,  authReq, authOK, captureReq, captured, receipt };

mtype = { shipInfo,   reqForShipOptions,  shipperOptionQuote, senderOptionQuote, 
chooseOption, shipOrder, shipment, confirm };

chan  to_seller= [CHANLEN] of { mtype,byte, byte, byte};
chan  to_buyer= [CHANLEN] of { mtype,byte, byte, byte};
chan  to_payee= [CHANLEN] of { mtype,byte, byte, byte};
chan  to_payer= [CHANLEN] of { mtype,byte, byte, byte};
chan  to_gateway= [CHANLEN] of { mtype,byte, byte, byte};
chan  to_sender= [CHANLEN] of { mtype,byte, byte, byte};
chan  to_receiver= [CHANLEN] of { mtype,byte, byte, byte};
chan  to_shipper= [CHANLEN] of { mtype,byte, byte, byte};

/* composition axiom variables */
chan c_dataflow_axiom3  = [CHANLEN] of {byte};
chan c_dataflow_axiom4  = [CHANLEN] of {byte};
bit b_implication_axiom5 =0;
bit b_implication_axiom6   =0;
bit b_eventorder_axiom7  =0;


/* commitment  conditions*/
bool cc_pay;
bool cc_goods;

/* 
mtype cc1_state = cc_idle ;
proctype cc1() 
{
	bit r1=1, r2=1;

	cc1_state = cc_active;
	do
	::cc_pay && r1 ->
		cc1_state = cc_base;
		r1=0;
	::cc_goods && r2->
		cc1_state  = cc_discharged;
		r2=0;
		break;
	od;

}
*/

byte seller_rfq_itemID;
byte seller_quote_itemID;
byte seller_acceptQuote_itemID;
byte seller_rejectQuote_itemID;
byte seller_quote_itemPrice=110;
byte seller_acceptQuote_itemPrice;
byte seller_rejectQuote_itemPrice;

bit seller_rfq;
bit seller_quote;
bit seller_acceptQuote;
bit seller_rejectQuote;



proctype seller()
{
   
  mtype msg;
  byte tmp1, tmp2, tmp3, tmp4;
  bit start=1;
  bit rule1=1, rule2=1, rule3=1;  
  
  byte scid; /*Seller commitment id*/
  chan me = [0] of { mtype, byte};

   do
     ::start && rule1 && to_seller?[reqForQuote]-> 	
    	to_seller?reqForQuote(seller_rfq_itemID, tmp3, tmp4);
	seller_rfq=1;
	start = 0;
	rule1=0; 
    :: seller_rfq  && rule2 ->
	seller_quote_itemID=seller_rfq_itemID;
    	to_buyer!quote(seller_quote_itemID, seller_quote_itemPrice);
	/* run cc1(); */
	/***********/
	to_cc_create!cc_create(me, to_seller_cc, to_buyer_cc);
	me?cc_cid(scid);
	seller_cid = scid;
	
    	seller_quote=1;
	rule2 =0;
	
    :: seller_quote && rule3 && to_seller?[acceptQuote]->
	to_seller?acceptQuote(seller_acceptQuote_itemID, seller_acceptQuote_itemPrice, tmp3);
	seller_acceptQuote=1;
	rule3=0;
	break;
    :: seller_quote && rule3 && to_seller?[rejectQuote]->
	to_seller?rejectQuote(seller_rejectQuote_itemID, seller_rejectQuote_itemPrice, tmp3);
	seller_rejectQuote=1;
	rule3=0;
	break;
    od;
 }

bit buyer_rfq;
bit buyer_quote;
bit buyer_acceptQuote;
bit buyer_rejectQuote;

byte buyer_rfq_itemID = 10;
byte buyer_quote_itemID;
byte buyer_acceptQuote_itemID;
byte buyer_rejectQuote_itemID;

byte buyer_quote_itemPrice;
byte buyer_acceptQuote_itemPrice;
byte buyer_rejectQuote_itemPrice;


proctype buyer()
{
  byte tmp1;
  bit start=1;
  bit r1 =1, r2=1, r3= 1, r4 =1;

  byte bcid;/*Used to store the buyer commitment ID*/
  chan me = [0] of { mtype, byte};
  
  do
  ::start && r1-> 
  	to_seller!reqForQuote(buyer_rfq_itemID);
  	buyer_rfq =1;
	start=0;
	r1=0;
  ::buyer_rfq && r2 && to_buyer?[quote]->
  	to_buyer?quote(buyer_quote_itemID, buyer_quote_itemPrice, tmp1);
	buyer_quote=1;
	r2=0;
  ::buyer_quote && r3->
  	to_seller!acceptQuote(buyer_quote_itemID , buyer_quote_itemPrice); 
	/******Create Buyer Commitment****/
	/* Create a Commitment that say if seller ships, buyer will pay */
	to_cc_create!cc_create(me, to_buyer_cc, to_seller_cc);
	/* Receive the cid for this commitment */
	me?cc_cid(bcid);
	buyer_cid= bcid;
	/* axiom 3 */
	c_dataflow_axiom3!buyer_quote_itemID;
	c_dataflow_axiom4!buyer_quote_itemPrice;
	buyer_acceptQuote=1;
	r3=0;
  	break;
  ::buyer_quote && r4 ->
  	to_seller!rejectQuote(buyer_quote_itemID, buyer_quote_itemPrice);
	buyer_rejectQuote=1;
	r4=0;
  	break;
  od;
 }

bit payer_paymentInfo=0;
bit payer_receipt =0;

byte payer_paymentInfo_cardNo =123;
byte payer_paymentInfo_expDate = 234;
byte payer_expectedAmount ;
byte payer_receipt_amount;

proctype payer() {

   byte tmp1, tmp2;
   bit start=1;
   bit r1=1, r2=1;


  do
    :: start && r1->
         	to_payee!paymentInfo(payer_paymentInfo_cardNo, payer_paymentInfo_expDate);
	start=0;
	payer_paymentInfo=1;
	r1 =0;
   ::payer_paymentInfo && r2 && to_payer?[receipt]->
   	to_payer?receipt(payer_receipt_amount, tmp1, tmp2);
                  	payer_receipt=1;
	r2 =0;
	break;
    :: buyer_rejectQuote->
	break;
  od;
}


byte payee_paymentInfo_cardNO;
byte payee_paymentInfo_expDate;
byte payee_authReq_cardNO;
byte payee_authReq_expDate;
byte payee_authReq_amount;
byte payee_authOK_tokenNO;
byte payee_authOK_authorizedAmount;
byte payee_receipt_authorizedAmount;
byte payee_captureReq_tokenNO;
byte payee_captured_capturedAmount;

bit payee_paymentInfo;
bit payee_authReq;
bit  payee_authOK;
bit payee_receipt;
bit payee_captureReq;
bit payee_captured;


proctype payee () 
{
    byte amount, tmp1, tmp2;
    chan me = [0] of { mtype, byte};

     bit start=1;
     bit r1 =1, r2=1, r3=1, r4=1, r5=1, r6=1, r7=1, r8=1;
   do
     :: start  && r1 && to_payee?[paymentInfo]->
           to_payee?paymentInfo(payee_paymentInfo_cardNO, payee_paymentInfo_expDate, tmp1);
           start  =0;
          payee_paymentInfo =1;
           r1 =0;

     ::payee_paymentInfo && r2 && c_dataflow_axiom4?[amount]->
           c_dataflow_axiom4? amount;
           payee_authReq_amount = amount;
           payee_authReq_cardNO = payee_paymentInfo_cardNO;
           payee_authReq_expDate = payee_paymentInfo_expDate; 
           to_gateway!authReq (payee_authReq_cardNO, payee_authReq_expDate,  payee_authReq_amount ) ;
            payee_authReq = 1;
           r2 =0;
     ::payee_authReq&& r3 && to_payee?[authOK]->
           /*b_eventorder_axiom8 ==1; */
           to_payee?authOK(payee_authOK_tokenNO, payee_authOK_authorizedAmount, tmp1); 
           payee_authOK =1;
           b_implication_axiom5 = 1;
           b_eventorder_axiom7 = 1;
           r3 =0;
   
      :: payee_authOK && r4->
           payee_receipt_authorizedAmount = amount;
           to_payer!receipt(payee_receipt_authorizedAmount);
           payee_receipt =1;
           r4 =0;       
       :: payee_receipt  && r5->             
           payee_captureReq_tokenNO = payee_authOK_tokenNO;
           to_gateway!captureReq(payee_captureReq_tokenNO);
           payee_captureReq =1;
           r5 =0;
       :: payee_captureReq && r6 && to_payee?[captured]->
           to_payee?captured(payee_captured_capturedAmount, tmp1, tmp2);  
           payee_captured=1;
           r6 =0;
           
           /*****Received Payment, cleared the pre-condition of seller's commitment******/
	   to_cc_mgt!cc_base(me, seller_cid);
	   
	   /*Payment received, so we can discharge the buyer's commitment*/
	   to_cc_mgt!cc_discharge(me, buyer_cid);
           
           break;
      :: buyer_rejectQuote->
	break;

    od;
}


bit gateway_authReq;
bit gateway_authOK;
bit gateway_capturedReq;
bit gateway_captured;

byte gateway_authReq_cardNO;
byte gateway_authReq_expDate;
byte gateway_authReq_amount;
byte gateway_authOK_tokenNO;
byte gateway_authOK_amount;
byte gateway_captured_amount;
byte gateway_captureReq_token;   

proctype gateway()
{
    bit start=1;
    bit r1 =1, r2=1, r3=1, r4=1;
    byte tmp1, tmp2;

end:
  do
       :: start && r1 && to_gateway?[authReq]->
	to_gateway?authReq(gateway_authReq_cardNO, gateway_authReq_expDate, gateway_authReq_amount);
 	gateway_authOK_tokenNO  = _pid ;
	start=0; 
	gateway_authReq =1;
	r1=0;
        :: gateway_authReq && r2->
	gateway_authReq_amount = gateway_authReq_amount;
	to_payee!authOK( gateway_authOK_tokenNO, gateway_authReq_amount);
	gateway_authOK =1;
	r2=0;
        ::gateway_authOK && r3 && to_gateway?[captureReq]->
	to_gateway?captureReq(gateway_captureReq_token, tmp1, tmp2);
	gateway_capturedReq  =1;


	/* for implication 5 */
           	cc_pay = true;
	r3=0;
        :: gateway_capturedReq && r4 ->
	gateway_captured_amount = gateway_authReq_amount;
	to_payee!captured(gateway_captured_amount);
	gateway_captured =1;
	r4=0;
	break;
      :: buyer_rejectQuote->
	break;
  od;
 }


bit receiver_shipInfo = 0;
bit receiver_senderOptionQuote =0;
bit receiver_chooseOption =0;
bit receiver_shipment =0;
bit receiver_confirm =0;


byte receiver_shipInfo_shipAddress = 111;
byte receiver_senderOptionQuote_shipOption;
byte receiver_senderOptionQuote_senderQuote;
byte receiver_chooseOption_shipOption;
byte receiver_chooseOption_senderQuote;
byte receiver_shipment_item;
byte receiver_confirm_item;
proctype receiver()
{

  chan me = [0] of { mtype, byte, byte};
  byte tmp1, tmp2;
  bit start=1;
  bit r1=1, r2=1, r3=1, r4=1, r5=1;
  do
      ::start  && r1 ->
	to_sender!shipInfo(receiver_shipInfo_shipAddress);
	start =0;
	receiver_shipInfo =1;
	r1=0;
       :: receiver_shipInfo  && r2 && to_receiver?[senderOptionQuote]->
	to_receiver?senderOptionQuote(receiver_senderOptionQuote_shipOption, receiver_senderOptionQuote_senderQuote, tmp1);
	receiver_senderOptionQuote =1;
	r2=0;
       :: receiver_senderOptionQuote  && r3->
	receiver_chooseOption_shipOption =receiver_senderOptionQuote_shipOption;
	receiver_chooseOption_senderQuote = receiver_senderOptionQuote_senderQuote;
	to_sender!chooseOption(receiver_chooseOption_shipOption,receiver_chooseOption_senderQuote);
	receiver_chooseOption =1;
	r3=0;
       :: receiver_chooseOption   && r4 && to_receiver?[shipment]->
	to_receiver?shipment(receiver_shipment_item, tmp1, tmp2);
	receiver_shipment = 1;
	r4=0;
	/*****Received Shipment******/
	to_cc_mgt!cc_discharge(me, seller_cid)
	
        :: receiver_shipment  && r5->
	receiver_confirm_item =  receiver_shipment_item;
	to_sender!confirm(receiver_confirm_item);
	receiver_confirm =1;
	r5=0;
	break;
      :: buyer_rejectQuote->
	break;
   od;
 }

bit sender_shipInfo = 0;
bit sender_reqForShipOptions;
bit sender_shipperOptionQuote;
bit sender_senderOptionQuote;
bit sender_chooseOption;
bit sender_shipOrder;
bit sender_confirm;

byte sender_shipInfo_shipAddress;
byte sender_reqForShipOptions_shipAddress;
byte sender_reqForShipOptions_item;
byte sender_shipperOptionQuote_shipOption;
byte sender_shipperOptionQuote_shipperQuote;
byte sender_senderOptionQuote_shipOption;
byte sender_senderOptionQuote_senderQuote;
byte sender_chooseOption_shipOption;
byte sender_chooseOption_senderQuote;

byte sender_shipOrder_shipAddress;
byte sender_shipOrder_shipOption;
byte sender_shipOrder_item;

byte sender_confirm_confirmedItem;


proctype sender()
{
     byte item, tmp1, tmp2;
     bit start=1;
     bit r1 =1, r2=1, r3=1, r4=1, r5=1, r6=1, r7=1;
      
do 
     :: start && r1 && to_sender?[shipInfo]-> 
	to_sender?shipInfo (sender_shipInfo_shipAddress, tmp1, tmp2);
	start =0;
	sender_shipInfo =1;
	r1 =0;
      :: sender_shipInfo  && r2 && c_dataflow_axiom3?[item]->
	c_dataflow_axiom3? item;
	sender_reqForShipOptions_item = item;
	to_shipper!reqForShipOptions( sender_reqForShipOptions_shipAddress, sender_reqForShipOptions_item);
	sender_reqForShipOptions =1;
	r2 =0;
       :: sender_reqForShipOptions  && r3 && to_sender?[shipperOptionQuote]->
	to_sender?shipperOptionQuote(sender_shipperOptionQuote_shipOption, sender_shipperOptionQuote_shipperQuote, tmp1);
	sender_shipperOptionQuote =1;
	r3 =0;
       :: sender_shipperOptionQuote  && r4->
	 /* seller can add a little premium here*/
	sender_senderOptionQuote_shipOption= sender_shipperOptionQuote_shipOption;
 	sender_senderOptionQuote_senderQuote = sender_shipperOptionQuote_shipperQuote + 1;
  	to_receiver!senderOptionQuote(sender_senderOptionQuote_shipOption, sender_senderOptionQuote_senderQuote);
	sender_senderOptionQuote =1;
	r4 =0;
         :: sender_senderOptionQuote  && r5 && to_sender?[chooseOption]->
	to_sender?chooseOption(sender_chooseOption_shipOption, sender_chooseOption_senderQuote, tmp1);
	sender_chooseOption =1;
	r5 =0;
          :: sender_chooseOption  && r6 && b_eventorder_axiom7->
	/* for axiom 7*/	
	sender_shipOrder_item = sender_reqForShipOptions_item;
	sender_shipOrder_shipOption = sender_chooseOption_shipOption;
	sender_shipOrder_shipAddress = sender_shipInfo_shipAddress;
	to_shipper!shipOrder(sender_shipOrder_item, sender_shipOrder_shipOption, sender_shipOrder_shipAddress);
	/*b_eventorder_axiom8 = 1; */
	sender_shipOrder =1;
	r6 =0;
           :: sender_shipOrder  && r7 && to_sender?[confirm]->
	to_sender?confirm(sender_confirm_confirmedItem, tmp1, tmp2);       
	sender_confirm =1;
	r7 =0;
	break;
          :: buyer_rejectQuote->
	break;
     od;

 }

bit shipper_reqForShipOptions;
bit shipper_shipperOptionQuote;
bit shipper_shipOrder;
bit shipper_shipment;

byte shipper_reqForShipOptions_shipAddress;
byte shipper_reqForShipOptions_item;
byte shipper_shipperOptionQuote_shipOption=1;
byte shipper_shipperOptionQuote_shipQuote = 6;

byte shipper_shipOrder_shipAddress;
byte shipper_shipOrder_item;
byte shipper_shipOrder_shipOption;

byte shipper_shipment_item;

proctype shipper()
{


     byte tmp1, tmp2;
     bit start=1;
     bit r1=1, r2=1, r3=1, r4=1;

do
      :: start && r1 && to_shipper?[reqForShipOptions]->
       	to_shipper?reqForShipOptions(shipper_reqForShipOptions_shipAddress, shipper_reqForShipOptions_item, tmp1);
	start =0;
                  shipper_reqForShipOptions =1;
	r1=0;
      ::  shipper_reqForShipOptions && r2 ->
	to_sender!shipperOptionQuote(shipper_shipperOptionQuote_shipOption, shipper_shipperOptionQuote_shipQuote);
	shipper_shipperOptionQuote =1;
	r2=0;
       ::  shipper_shipperOptionQuote  && r3 && to_shipper?[shipOrder]->
	to_shipper?shipOrder ( shipper_shipOrder_item, shipper_shipOrder_shipOption, shipper_shipOrder_shipAddress);
	shipper_shipOrder =1;
	 r3=0;

        :: shipper_shipOrder  && r4->
	to_receiver!shipment(shipper_shipment_item);
	cc_goods = true;
	shipper_shipment =1;
	r4=0;
	break;
          :: buyer_rejectQuote->
	break;
   od;
 }

proctype customer() 
{
	run buyer();
 	run payer();
	run receiver();
}

proctype merchant() 
{
	run seller();
	run payee();
	run sender();

}


init
{

	run gateway();
	run shipper();
	run customer();
	run merchant();
}
